import java.util.Random;
import java.util.Scanner;

public class Dice {
    private int numberSides;
    private Random rand;
    private int value;

    public Dice (int sides) {
        if (sides > 0) {
            this.numberSides = sides;
        } else {
            this.numberSides = 1;
        }
        this.rand = new Random();
        this.roll();
    }

    public void roll() {
        // Get the next value of the dice6
        this.value = this.rand.nextInt(this.numberSides) + 1;
    }

    /*

     * GETTERS *

    */
    public int getValue() {
        return this.value;
    }

    public Random getRandom() {
        return this.rand;
    }

    public int getSides() {
        return this.numberSides;
    }

    public String toString() {
        return "" + this.getValue();
    }
}


class Exercice2 {

    private static void UseDice() {
        Dice dice6 = new Dice(6);
        System.out.println("Valeur initiale du dé à 6 faces: " + dice6.getValue());
        for (int i = 0; i < 20; i++) {
            dice6.roll();
            System.out.println("Lancer n°" + (i+1) + ", " + dice6.getValue());
        }

        Dice dice10 = new Dice(10);
        System.out.println("\nValeur initiale du dé à 10 faces: " + dice10.getValue());
        for (int i = 0; i < 20; i++) {
            dice10.roll();
            System.out.println("Lancer n°" + (i+1) + ", " + dice10.getValue());
        }
    }

    private static void OneDicePlayerGame() {

        System.out.print("Merci d'entrer votre nom: ");
        Scanner scanner = new Scanner(System.in);
        String username = scanner.nextLine();
        scanner.close();

        DicePlayer player = new DicePlayer(username);
        Dice dice = new Dice(6);

        player.playUntil(dice, 20);
        System.out.println("Vous avez effectué " + player.getDiceRolls() + " lancers, pour un total de " + player.getTotalValue() + " points. Bravo.");
    }
    
    public static void main (String[] args) {
        // Main function.
        OneDicePlayerGame();
    }

}
