package tp03.ex01;

public class Card {

	private Color color;
	private Rank rank;

	public Card (Color color, Rank rank) {
		this.color = color;
		this.rank = rank;
	}

	public Card (String color, String rank) {
		for (int i = 0; i < Color.values().length; i++) {
			if (Color.values()[i].equals(color)) {
				this.color = Color.valueOf(color);
			}
		}

		for (int i = 0; i < Rank.values().length; i++) {
			if (Rank.values()[i].equals(color)) {
				this.rank = Rank.valueOf(rank);
			}
		}
	}

	public Color getColor() {
		return this.color;
	}

	public Rank getRank() {
		return this.rank;
	}

	public boolean equals(Card other) {
		if (this == other) {
			return true;
		}
		if (other == null) {
			return false;
		}
		if (this.color.equals(other.color) && this.rank.equals(other.rank)) {
			return true;
		}
		return false;
	}

	public String toString() {
		return this.rank.toString() + " of " + this.color.toString();
	}

	public int compareColor(Card other) {
		int indexOfSelf = 0;
		int indexOfOther = 0;
		for (int i = 0; i < Color.values().length; i++) {
			if (Color.values()[i].equals(this.color)) {
				indexOfSelf = i;
			}
			if (Color.values()[i].equals(other.color)) {
				indexOfOther = i;
			}
		}
		return indexOfSelf - indexOfOther;
	}

	public int compareRank(Card other) {
		int indexOfSelf = 0;
		int indexOfOther = 0;
		for (int i = 0; i < Rank.values().length; i++) {
			if (Rank.values()[i].equals(this.rank)) {
				indexOfSelf = i;
			}
			if (Rank.values()[i].equals(other.rank)) {
				indexOfOther = i;
			}
		}
		return indexOfSelf - indexOfOther;
	}

}